<?php

namespace common\logic\Order\Order;

use common\logic\BaseManager;
use common\logic\Product\Product\Product;
use common\logic\User\User\User;

/**
 * > Solver
 * @method string getFieldNameAmount($typeTotal = Order::AMOUNT_TOTAL, string $typeField = '')
 * @method float getOrderTotalVat(Order $order, string $typeTotal = Order::AMOUNT_TOTAL)
 * @method ?string getPaymentStatus(Order $order)
 * @method string getPointSaleSummary(Order $order)
 * @method string getOrderUsername(Order $order)
 * @method bool isLinkedToValidDocument(Order $order)
 * @method string getCommentReport(Order $order)
 * @method string getDateAsHtml(Order $order)
 * @method countProducts(Order $order): int
 * @method int getProductQuantityPieces(Product $product, array $orders)
 * @method int getProductQuantity(Product $product, array $orders, bool $ignoreCancel = false, string $unit = null)
 * @method string getHistoryClass(Order $order)
 * @method string getHistorySummary(Order $order)
 * @method string getLabelOrigin(Order $order, bool $withLabel = false)
 * @method float getOrderAmount(Order $order, string $type = Order::AMOUNT_TOTAL, bool $format = false)
 * @method float getOrderAmountWithTax(Order $order, string $type = Order::AMOUNT_TOTAL, bool $format = false)
 * @method bool isOrderStateOpen(Order $order)
 * @method bool isOrderStatePreparation(Order $order)
 * @method bool isOrderStateDelivered(Order $order)
 * @method bool isOrderBelongsToUser(Order $order, User $user = null)
 * @method string getDataJson(Order $order)
 *
 * Repository
 *
 * Builder
 *
 * Utils
 *
 */
class OrderManager extends BaseManager
{
    public function __construct()
    {
        $this->setContainer(new OrderContainer());
    }
}